package com.steerinfo.TimedTask.lgwgt.controller;

import com.steerinfo.framework.controller.BaseRESTfulController;
import com.steerinfo.framework.controller.RESTfulResult;
import com.steerinfo.framework.service.pagehelper.PageList;
import com.steerinfo.framework.utils.collection.ListUtils;
import com.steerinfo.TimedTask.lgwgt.model.LgWgt;
import com.steerinfo.TimedTask.lgwgt.service.ILgWgtService;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Arrays;
import java.util.HashMap;
import java.util.List;

/**
 * LgWgt RESTful接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-10-22 04:55
 * 类描述
 * 修订历史：
 * 日期：2021-10-22
 * 作者：generator
 * 参考：
 * 描述：LgWgt RESTful接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@RestController
@RequestMapping("/${api.version}/lgwgts")
public class LgWgtController extends BaseRESTfulController {

    @Autowired
    ILgWgtService lgWgtService;

    @ApiOperation(value="获取列表", notes="分页查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("lgwgt:view")
    @GetMapping(value = "/")
    public RESTfulResult list(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<LgWgt> list = lgWgtService.queryForPage(parmas, pageNum, pageSize);
        return success(list);
    }

    @ApiOperation(value="获取列表", notes="分页模糊查询")
    @ApiImplicitParams({
        @ApiImplicitParam(name = "pageNum", value = "查询页数", required = false, dataType = "Integer"),
        @ApiImplicitParam(name = "pageSize", value = "每页记录数", required = false, dataType = "Integer")
    })
    //@RequiresPermissions("lgwgt:view")
    @GetMapping(value = "/like/")
    public RESTfulResult listLike(@RequestParam HashMap parmas,Integer pageNum, Integer pageSize){
        PageList<LgWgt> list = lgWgtService.queryLikeForPage(parmas, pageNum, pageSize);
        return success(list);
    }
    
    @ApiOperation(value="创建", notes="根据LgWgt对象创建")
    @ApiImplicitParam(name = "lgWgt", value = "详细实体lgWgt", required = true, dataType = "LgWgt")
    //@RequiresPermissions("lgwgt:create")
    @PostMapping(value = "/")
    public RESTfulResult add(@ModelAttribute LgWgt model){
        LgWgt lgWgt = lgWgtService.add(model);
        return success(lgWgt);
    }

    @ApiOperation(value="获取详细信息", notes="根据url的id来获取详细信息")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Long")
    //@RequiresPermissions("lgwgt:view")
    @GetMapping(value = "/{id}")
    public RESTfulResult get(@PathVariable Long id){
        LgWgt lgWgt = lgWgtService.getById(id);
        return success(lgWgt);
    }

    @ApiOperation(value="更新详细信息", notes="根据url的id来指定更新对象，并根据传过来的lgWgt信息来更新详细信息")
    @ApiImplicitParams({
        @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Long"),
        @ApiImplicitParam(name = "lgWgt", value = "详细实体lgWgt", required = true, dataType = "LgWgt")
    })
    //@RequiresPermissions("lgwgt:update")
    @PutMapping(value = "/{id}", produces  = "application/json;charset=UTF-8")
    public RESTfulResult update(@PathVariable Long id, @RequestBody LgWgt model){
        model.setId(id);
        LgWgt lgWgt = lgWgtService.modify(model);
        return success(lgWgt);
    }

    @ApiOperation(value="删除", notes="根据url的id来指定删除对象")
    @ApiImplicitParam(paramType = "path", name = "id", value = "ID", required = true, dataType = "Long")
    //@RequiresPermissions("lgwgt:delete")
    @DeleteMapping(value = "/{id}")//Long
    public RESTfulResult delete(@PathVariable String id){
    	List<String> list = Arrays.asList(id.split(","));
    	if(ListUtils.isNotEmpty(list)) {
	    	List<Long> ids = ListUtils.convertList(list);
			  lgWgtService.delete(ids);
    	}
      return success();
    }
}
